CreateEvents proc
	
	push esi
	push edi
	push edx
	
	;1
	invoke CreateEvent,0,FALSE,FALSE,ASTR("prepareheader")
	mov hPrepareEvent,eax
	
	;2
	invoke CreateEvent,0,FALSE,FALSE,ASTR("index")
	mov hIndexEvent,eax
	
	;3
	invoke CreateEvent,0,FALSE,FALSE,ASTR("chartjmptblpadding")
	mov hChart1Event,eax
	;4
	invoke CreateEvent,0,FALSE,FALSE,ASTR("chartcolordepth")
	mov hChart2Event,eax
	;5
	invoke CreateEvent,0,FALSE,FALSE,ASTR("chartpixelmemory")
	mov hChart3Event,eax
	
;	;6
;	invoke CreateEvent,0,FALSE,FALSE,ASTR("paintbmi")
;	mov hPaint1Event,eax
;	;7
;	invoke CreateEvent,0,FALSE,FALSE,ASTR("paintpixels")
;	mov hPaint2Event,eax
	
	pop edx
	pop edi
	pop esi

	ret

CreateEvents endp

CreateThreads proc
	LOCAL ThreadID:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;1
	invoke CreateThread,0,0,offset PrepareThread,0,0,addr ThreadID
	invoke CloseHandle,eax
	
	;2
	invoke CreateThread,0,0,offset IndexThread,0,0,addr ThreadID
	invoke CloseHandle,eax
	
	;3, 4 and 5
	invoke CreateThread,0,0,offset ChartThread,0,0,addr ThreadID
	invoke CloseHandle,eax
	
;	;6 and 7
;	invoke CreateThread,0,0,offset PaintThread,0,0,addr ThreadID
;	invoke CloseHandle,eax
	
	pop edx
	pop edi
	pop esi

	ret

CreateThreads endp

PrepareThread proc lParam:dword
	
	push esi
	push edi
	push edx
	
	invoke WaitForSingleObject,hPrepareEvent,INFINITE
	.if eax==WAIT_OBJECT_0
		invoke prepareHeaders3
	.endif
	
	invoke CloseHandle,hPrepareEvent
	
	pop edx
	pop edi
	pop esi

	ret

PrepareThread endp

IndexThread proc lParam:dword
	
	push esi
	push edi
	push edx
	
	invoke WaitForSingleObject,hIndexEvent,INFINITE
	.if eax==WAIT_OBJECT_0
		invoke bsbIndex3
	.endif
	
	invoke CloseHandle,hIndexEvent
	
	pop edx
	pop edi
	pop esi

	ret

IndexThread endp

ChartThread proc lParam:dword
	
	push esi
	push edi
	push edx
	
	lea edi,hChartEvents
	mov eax,hChart1Event
	mov dword ptr [edi],eax
	mov eax,hChart2Event
	mov dword ptr [edi+4],eax
	mov eax,hChart3Event
	mov dword ptr [edi+8],eax
	
	invoke WaitForMultipleObjects,3,offset hChartEvents,TRUE,INFINITE
	.if eax==WAIT_OBJECT_0
			invoke bsbChart3
		
	.endif
	
	invoke CloseHandle,hChart1Event
	invoke CloseHandle,hChart2Event
	invoke CloseHandle,hChart3Event
	
	pop edx
	pop edi
	pop esi

	ret

ChartThread endp

