MainDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL w:dword
	LOCAL h:dword
	LOCAL rect:RECT
	LOCAL pvBits:dword
    LOCAL ptChart:POINT
    LOCAL ofn:OPENFILENAME
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push hWin
		pop hMain
		invoke GetDlgItem,hWin,IDC_CHART
		mov hCHART,eax
		invoke GetDC,eax
		mov hDC,eax
		
		invoke CreateDIBSection,hDC,pBMI,DIB_RGB_COLORS,addr pvBits,0,0
		mov hBitmap,eax
			
		invoke GetProcessHeap
		mov hHeap,eax
		
		;Allocate memory for the bitmap header
		mov eax,sizeof BITMAPINFOHEADER
		add eax,1024 ;sizeof colortable
		invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
		mov pBMI,eax
		mov dword ptr [eax].BITMAPINFOHEADER.biSize,sizeof BITMAPINFOHEADER
		mov word ptr [eax].BITMAPINFOHEADER.biPlanes,1
		mov word ptr [eax].BITMAPINFOHEADER.biBitCount,8
		
		invoke CreateEvents
		
		invoke SetWindowLong,hCHART,GWL_WNDPROC,offset ChartProc
		mov OldChartProc,eax
		
		
	.elseif eax==WM_COMMAND
		.if lParam==0
			mov eax,wParam
			.if ax==IDM_ITEM
				invoke RtlMoveMemory,offset szFileName,ASTR("6142_1.kap"),11
				invoke crt_fopen,offset szFileName,ASTR("r")
				.if eax!=0
					invoke crt_fclose,eax
				.else
					mov ofn.lStructSize,sizeof ofn
					push hWin
					pop ofn.hWndOwner
					push hInstance
					pop ofn.hInstance
					mov ofn.lpstrFile,offset szFileName
					mov ofn.nMaxFile,256
					mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER
					invoke GetOpenFileName,addr ofn
				.endif
				invoke GetTickCount
				mov tickcount,eax
				invoke CreateThreads
				invoke bsbHeader3
				
			.elseif ax==IDM_PART
				invoke RtlMoveMemory,offset szFileName,ASTR("V_1.kap"),8
				invoke crt_fopen,offset szFileName,ASTR("r")
				.if eax!=0
					invoke crt_fclose,eax
				.else
					mov ofn.lStructSize,sizeof ofn
					push hWin
					pop ofn.hWndOwner
					push hInstance
					pop ofn.hInstance
					mov ofn.lpstrFile,offset szFileName
					mov ofn.nMaxFile,256
					mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER
					invoke GetOpenFileName,addr ofn
				.endif
				invoke GetTickCount
				mov tickcount,eax
				invoke CreateThreads
				invoke bsbHeader3
				
			.elseif ax==IDM_PART2
				
			.elseif ax==IDM_COMP
				
			.elseif ax==IDM_CLOSE
				invoke SendMessage,hWin,WM_CLOSE,0,0
				
			.endif
		.endif
		
	.elseif eax==WM_LBUTTONDOWN
		invoke IsWindowVisible,hCHART
		.if eax
			invoke ClientToScreen,hCHART,addr ptChart
			invoke ScreenToClient,hWin,addr ptChart
			mov eax,lParam
			and eax,0FFFFh
			sub eax,ptChart.x
			mov x,eax
			mov eax,lParam
			shr eax,16
			sub eax,ptChart.y
			mov y,eax
			
			mov eax,FALSE
			jmp @Exit
		.endif
		
	.elseif eax==WM_MOUSEMOVE
		.if wParam==MK_LBUTTON
			invoke IsWindowVisible,hCHART
			.if eax
				mov eax,lParam
				and eax,0FFFFh
				sub eax,x
				mov ecx,lParam
				shr ecx,16
				sub ecx,y
				.if sdword ptr eax>0
					mov eax,0
				.endif
				.if sdword ptr ecx>0
					mov ecx,0
				.endif
				invoke MoveWindow,hCHART,sdword ptr eax,sdword ptr ecx,imageW,imageH,TRUE 
				
				mov eax,FALSE
				jmp @Exit

			.endif
			
		.endif
		
	.elseif eax==WM_LBUTTONUP
		mov x,0
		mov y,0
		
	.elseif eax==WM_MOUSEWHEEL
		invoke IsWindowVisible,hCHART
		.if eax
			invoke GetClientRect,hCHART,addr rect
			invoke ClientToScreen,hCHART,addr ptChart
			invoke ScreenToClient,hWin,addr ptChart
			
			mov eax,wParam
			shr eax,16
			mov edx,rect.right
			mov ecx,rect.bottom
			.if sword ptr ax>0
				shr edx,1
				shr ecx,1
			.else
				shl edx,1
				shl ecx,1
			.endif
			mov imageW,edx
			mov imageH,ecx
			invoke MoveWindow,hCHART,ptChart.x,ptChart.y,imageW,imageH,TRUE
			invoke RedrawWindow,hCHART,0,0,RDW_INVALIDATE
			
		.endif
		
		
	.elseif eax==WM_CLOSE
		.if pIndex!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pIndex
			mov pIndex,0
		.endif
		.if pBMI!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pBMI
			mov pBMI,0
		.endif
		.if pPixelData!=0
			invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pPixelData
			mov pPixelData,0
		.endif
		invoke EndDialog,hWin,0
		
	.elseif eax==WM_SIZE
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh ;new width
		mov w,eax
		shr edx,16 ;new height
		mov h,edx
		
	.else
		mov eax,FALSE
		jmp @Exit
	.endif
	mov eax,TRUE

@Exit:	
	pop edx
	pop edi
	pop esi
	
	ret

MainDlgProc endp


