bsbHeader3 proc
	LOCAL stream:dword
	LOCAL index:dword
	LOCAL red:dword
	LOCAL green:dword
	LOCAL blue:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	;Allocate tempary memory for BSB header data
	mov bsbsize,32768
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,bsbsize
	mov pBSB,eax
		
	mov esi,pBMI
	
	invoke crt_fopen,offset szFileName,ASTR("rb")
	.if eax!=0
		mov stream,eax
		invoke crt_fseek,stream,0,SEEK_SET
		
@Read:	mov edi,pBSB
		invoke crt_fread,edi,bsbsize,1,stream
		.if eax!=1
			jmp @Exit
		.endif
		
		;check if end of header has been read to memory
		mov ecx,bsbsize
		mov al,1Ah
		repne scasb
		mov edx,bsbsize
		sub edx,ecx
		xchg edx,ecx
		push edx ;Store size after end of header
		
		mov edi,pBSB
@Next:	mov esi,edi
		mov al,0Ah
		repne scasb
		mov word ptr [edi-2],0
		
		call @Size
		cmp eax,2
		je @F
		call @Depth
		cmp eax,1
		je @F
		call @ColorTable
		
@@:		or ecx,ecx 
		jne @Next ;If not end of memory
		pop edx ;Restore size after end of header
		or edx,edx
		je @Read ;If size is zero end of header is not read. Read further.
		
@Exit:	invoke crt_fclose,stream
		invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pBSB
		mov pBSB,0
	.endif
	
	pop edx
	pop edi
	pop esi
	
	ret
	
;=== Subfunctions ===================================================================
@Size:
	push ecx
	invoke StrStr,esi,ASTR("RA=")
	.if eax!=0
		mov ecx,eax
		invoke crt_sscanf,ecx,ASTR("RA=%d,%d"),offset bsbW,offset bsbH
		push eax
		.if eax==2
			invoke SetEvent,hPrepareEvent ;Run prepareHeader
			invoke SetEvent,hIndexEvent ;Run bsbIndex jumptable
		.endif
		pop eax
	.endif
	pop ecx
	retn
	
@Depth:
	push ecx
	invoke crt_sscanf,esi,ASTR("IFM/%d"),offset ColorDepth
	push eax
	.if eax==1
		invoke SetEvent,hChart2Event ;Ready to run bsbChart (1 of 3)
	.endif
	pop eax
	pop ecx
	retn
	
@ColorTable:
	push ecx
	invoke crt_sscanf,esi,ASTR("RGB/%d,%d,%d,%d"),addr index,addr red,addr green,addr blue
	.if eax==4
		mov eax,index
		mov esi,pBMI
		mov dword ptr [esi].BITMAPINFOHEADER.biClrUsed,eax
		mov dword ptr [esi].BITMAPINFOHEADER.biClrImportant,eax
		dec eax
		mov ecx,4
		mul ecx
		mov edx,pBMI
		add edx,sizeof BITMAPINFOHEADER
		add edx,eax
		mov eax,blue
		mov byte ptr [edx],al
		inc edx
		mov eax,green
		mov byte ptr [edx],al
		inc edx
		mov eax,red
		mov byte ptr [edx],al
		inc edx
		mov byte ptr [edx],0
	.endif
	pop ecx
	retn
	
bsbHeader3 endp
